#property indicator_separate_window //  .  
#property indicator_buffers 2
#property indicator_color1 Blue // 
#property indicator_style1 0
#property indicator_color2 Red // 
#property indicator_style2 0
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 80
#property indicator_level2 20

//  
   // MA
extern int MAperiod=3; //  MA
extern int MAMethod=0; //  
extern int PosPrice=0; //    (Close)
extern int MaxPrice=2; //     (High)
extern int MinPrice=3; //     (Low)
   // 
extern int Kperiod=5; // %K
extern int Dperiod=3; // %D 
extern int Slowing=3; // 
extern int Dmethod=0; //  MA 
// .
double   Main[], // 
         Signal[], // 
         Pos[], //  
         Max[], //   
         Min[]; //   

void init() {
   //   
   SetIndexBuffer(0,Main); //    
   SetIndexStyle(0,DRAW_LINE);
   string _str="("+Kperiod+","+Slowing+")";
   SetIndexLabel(0,"Main"+_str);
   SetIndexBuffer(1,Signal); // 
   SetIndexStyle(1,DRAW_LINE);
   _str="("+Dperiod+")";
   SetIndexLabel(1,"Signal"+_str);
   //  
      //   
   IndicatorBuffers(5);
   SetIndexBuffer(2,Pos); //  
   SetIndexBuffer(3,Max); //   
   SetIndexBuffer(4,Min); //   
   //  
   string ShName=ShName+"Stoch ";
   ShName=ShName+" ("+Kperiod+","+Dperiod+","+Slowing+")";
   IndicatorShortName(ShName);   
  }

void start() {
   //  
   int limit=Bars-IndicatorCounted()-1;  
   if(limit>1) limit=Bars-1; 
   //  
   for(int i=limit; i>=0; i--) {
      Pos[i]=iMA(NULL,0,MAperiod,0,MAMethod,PosPrice,i); //  
      Max[i]=iMA(NULL,0,MAperiod,0,MAMethod,MaxPrice,i); //   
      Min[i]=iMA(NULL,0,MAperiod,0,MAMethod,MinPrice,i); //   
     }
   //   
   for(i=limit; i>=0; i--) Main[i]=Stoch(Kperiod,Slowing,i); //  - 
   //   
   for(i=limit; i>=0; i--) Signal[i]=iMAOnArray(Main,Bars,Dperiod,0,Dmethod,i);
  }

double Stoch(int Kperiod, int Slowing, int i) {  
   if(i+Kperiod+Slowing>Bars) return(-1); //   - 
   //     /
   double max,min,c;
   for(int j=i; j<i+Slowing; j++) {
      max+=Max[ArrayMaximum(Max,Kperiod,j)]; // 
      min+=Min[ArrayMinimum(Min,Kperiod,j)]; // 
      c+=Pos[j]; //  
     }
   //  
   double delta=max-min; // 
   if(delta==0) return(50); //   
   else return(100*(c-min)/delta); // 
  }

